#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h> 
#include <arpa/inet.h>
#include <errno.h>
#include <stdlib.h>
#include <stdio.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif
#ifdef HAVE_SYS_SELECT_H
#include<sys/select.h>
#endif
#ifdef HAVE_STRINGS_H
#include<strings.h>
#endif
#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif
#include <netdb.h>
#include <string.h>
#include <ctype.h>
#include "common.h"

#define COMMANDSIZE 512
#define ARGSIZE 256
#define SWEEPDELAY 4

/* FUNCTIONS */
void msrand (unsigned int seed );
int mrand (void);
unsigned int getkey();
void BOcrypt(unsigned char *buff, int len);

int pingsweepsubnet(char *arg1, int udpsock, int port);
int sendping(unsigned long dest, int port, int sock);
int sendpacket(unsigned char type, const char *str1, const char *str2, 
	       unsigned long dest, int port, int sock);

int getpong(int sock, int not_the_first_time);
int getinput(int sock);

void fixfilename(char *buff, const char *cwd, const char *path);
struct packlink* process_packet(unsigned char* ptr, int x, unsigned long id,
                                struct packlink* head, int is_final_packet);
void print_packets(struct packlink *head);


/* STRUCTURES */

struct packlink {
  int active;
  int size;
  unsigned long id;
  int is_final;
  int datasize;
  unsigned char* data;
  struct packlink *prev;
  struct packlink *next;
};



